Given an Android 3x3 key lock screen and two integers m and n, where 1 ≤ m ≤ n ≤ 9, count the total number of unlock patterns of the Android lock screen, which consist of minimum of m keys and maximum n keys.Rules for a valid pattern:Each pattern must connect at least m keys and at most n keys.All the keys must be distinct.If the line connecting two consecutive keys in the pattern passes through any other keys, the other keys must have previously selected in the pattern. No jumps through non selected key is allowed.The order of keys used matters.Explanation:| 1 | 2 | 3 || 4 | 5 | 6 || 7 | 8 | 9 |Invalid move: 4 - 1 - 3 - 6 Line 1 - 3 passes through key 2 which had not been selected in the pattern.Invalid move: 4 - 1 - 9 - 2Line 1 - 9 passes through key 5 which had not been selected in the pattern.Valid move: 2 - 4 - 1 - 3 - 6Line 1 - 3 is valid because it passes through key 2, which had been selected in the patternValid move: 6 - 5 - 4 - 1 - 9 - 2Line 1 - 9 is valid because it passes through key 5, which had been selected in the pattern.Example:Given m = 1, n = 1, return 9.

我自己的backtracking做法

最开始把cur设置为一个dummy value 0

 1 public class Solution { 2     int num = 0; 3     public int numberOfPatterns(int m, int n) { 4         for (int len=m; len<=n; len++) { 5             HashSet<Integer> visited = new HashSet<Integer>(); 6             count(visited, 0, 0, len); 7         } 8         return num; 9     }10     11     public void count(HashSet<Integer> visited, int cur, int pos, int len) {12         if (pos == len) {13             num++;14             return;15         }16         for (int elem=1; elem<=9; elem++) {17             if (visited.contains(elem)) continue;18             if (cur == 1) {19                 if (elem==3 && !visited.contains(2)) continue;20                 if (elem==7 && !visited.contains(4)) continue;21                 if (elem==9 && !visited.contains(5)) continue;22             }23             else if (cur == 2) {24                 if (elem == 8 && !visited.contains(5)) continue;25             }26             else if (cur == 3) {27                 if (elem==1 && !visited.contains(2)) continue;28                 if (elem==7 && !visited.contains(5)) continue;29                 if (elem==9 && !visited.contains(6)) continue;30             }31             else if (cur == 4) {32                 if (elem == 6 && !visited.contains(5)) continue;33             }34             else if (cur == 6) {35                 if (elem == 4 && !visited.contains(5)) continue;36             }37             else if (cur == 7) {38                 if (elem==1 && !visited.contains(4)) continue;39                 if (elem==3 && !visited.contains(5)) continue;40                 if (elem==9 && !visited.contains(8)) continue;41             }42             else if (cur == 8) {43                 if (elem==2 && !visited.contains(5)) continue;44             }45             else if (cur == 9) {46                 if (elem==1 && !visited.contains(5)) continue;47                 if (elem==3 && !visited.contains(6)) continue;48                 if (elem==7 && !visited.contains(8)) continue;49             }50             visited.add(elem);51             count(visited, elem, pos+1, len);52             visited.remove(elem);53         }54     }55 }

最好的DFS with Optimization beat 97%: https://discuss.leetcode.com/topic/46260/java-dfs-solution-with-clear-explanations-and-optimization-beats-97-61-12ms

Use an matrix to store the corssed number for each possible move and use DFS to find out all patterns.

The optimization idea is that 1,3,7,9 are symmetric, 2,4,6,8 are also symmetric. Hence we only calculate one among each group and multiply by 4.

 1 public class Solution { 2     // cur: the current position 3     // remain: the steps remaining 4     int DFS(boolean vis[], int[][] skip, int cur, int remain) { 5         if(remain < 0) return 0; 6         if(remain == 0) return 1; 7         vis[cur] = true; 8         int rst = 0; 9         for(int i = 1; i <= 9; ++i) {10             // If vis[i] is not visited and (two numbers are adjacent or skip number is already visited)11             if(!vis[i] && (skip[cur][i] == 0 || (vis[skip[cur][i]]))) {12                 rst += DFS(vis, skip, i, remain - 1);13             }14         }15         vis[cur] = false;16         return rst;17     }18     19     public int numberOfPatterns(int m, int n) {20         // Skip array represents number to skip between two pairs21         int skip[][] = new int[10][10];22         skip[1][3] = skip[3][1] = 2;23         skip[1][7] = skip[7][1] = 4;24         skip[3][9] = skip[9][3] = 6;25         skip[7][9] = skip[9][7] = 8;26         skip[1][9] = skip[9][1] = skip[2][8] = skip[8][2] = skip[3][7] = skip[7][3] = skip[4][6] = skip[6][4] = 5;27         boolean vis[] = new boolean[10];28         int rst = 0;29         // DFS search each length from m to n30         for(int i = m; i <= n; ++i) {31             rst += DFS(vis, skip, 1, i - 1) * 4;    // 1, 3, 7, 9 are symmetric32             rst += DFS(vis, skip, 2, i - 1) * 4;    // 2, 4, 6, 8 are symmetric33             rst += DFS(vis, skip, 5, i - 1);        // 534         }35         return rst;36     }37 }

更多相关文章

  1. 关于在使用gson解析json时建模与规范冲突的问题
  2. Android中使用javah生成jni头文件的正确方法
  3. AndroidStudio3.x 打开Android(安卓)Device Monitor正确做法
  4. android从fragment进入activity再返回实现刷新fragment的做法
  5. android 截屏的三种方法
  6. android的ListView点击item使item展开的做法的实现代码
  7. android 三档开关做法
  8. android:同时弹出顶部和底部菜单的做法
  9. android 混淆 gson

随机推荐

  1. Android对话框实例-注册对话框
  2. Android高手进阶——Android ANR解决案例
  3. Intent.FLAG_ACTIVITY_NEW_TASK和android
  4. 【android】Getting bitmap from a view
  5. android 晃动
  6. android property
  7. jWebSocket for Android
  8. Android PopupWindow显示位置和显示大小
  9. Android 工具类
  10. Android 全屏显示实例